<?php declare(strict_types = 1);

namespace DHLParcel\Shipping\Service;

use Shopware\Core\Checkout\Order\OrderEntity;
use GuzzleHttp\Client;

class WebhookService
{
    /**
     * @var Client
     */
    protected $httpClient;

    /**
     * @var ConfigService
     */
    protected $configService;

    /**
     * WebhookService constructor.
     * @param ConfigService $configService
     */
    public function __construct(ConfigService $configService)
    {
        $this->configService = $configService;
        $this->httpClient = new Client();
    }

    /**
     * @param OrderEntity $order
     */
    public function createDraft(OrderEntity $order): void
    {
        $webhookUrl = $this->configService->getWebhookUrl();
        if (empty($webhookUrl)) {
            return;
        }

        $this->httpClient->post($webhookUrl, array(
            'headers'   => [
                'Content-Type'          => 'application/json',
                'dhlparcel-connector'   => 'shopware6'
            ],
            'body'                  => json_encode($order)
        ));
    }
}
