<?php declare(strict_types=1);

namespace DHLParcel\Shipping\Subscriber;

use DHLParcel\Shipping\Service\ConfigService;
use DHLParcel\Shipping\Service\WebhookService;
use Symfony\Component\EventDispatcher\EventSubscriberInterface;
use Shopware\Core\Checkout\Cart\Event\CheckoutOrderPlacedEvent;

class NewOrderSubscriber implements EventSubscriberInterface
{
    /**
     * @var WebhookService
     */
    protected $webhookService;

    /**sdd
     * @var ConfigService
     */
    protected $configService;

    public function __construct(
        ConfigService $configService,
        WebhookService $webhookService
    ) {
        $this->configService = $configService;
        $this->webhookService = $webhookService;
    }

    /**
     * @return array
     */
    public static function getSubscribedEvents(): array
    {
        return[
            'Shopware\Core\Checkout\Cart\Event\CheckoutOrderPlacedEvent' => 'onCheckoutOrderPlaced'
        ];
    }

    /**
     * @param CheckoutOrderPlacedEvent $event
     */
    public function onCheckoutOrderPlaced(CheckoutOrderPlacedEvent $event)
    {
        if ($this->configService->isEnabled()) {
            $this->webhookService->createDraft($event->getOrder());
        }
    }
}
